%preliminary data

cons = xlsread ('consumption', 1, 'b1:b123');

nobs = 123;
cr = ones(nobs,1);
tr = (1:nobs)';
for i=1:nobs
tr2(i) = tr(i)^2;
end;

%log_cons=log(cons)
%const = FOLS(cons,[cr tr tr2']);
%c = cons-const.beta(2)*tr-const.beta(3)*tr2'; % eliminate quadratic trend

const = FOLS(cons,[cr tr]);
c = cons-const.beta(2)*tr; % eliminate linear trend from differenced data

save rawdata3_US_1977Q1_2016q3  c;

%log_cons=log(cons)
%const = FOLS(log_cons,[cr tr]);
%c = log_cons-const.beta(2)*tr; % eliminate linear trend from logged data
%save rawdata2_US_1977Q1_2016q3  c;

var c, k, L, A, Y ;

varexo zz ;

parameters alpha, beta, delta, teta, phi, vi, b, niz, n ;

alpha = 0.333; %capital share to match labor share of 2/3 in US KR, 1999 is 0.333;  
teta = 6; %elasticity of substitution for goods
phi = 2; %Frisch elasticity, in KR and BGM 4, in villaverde-ramirez 0.85
beta  = 0.99; %in KR 0.984
delta = 0.025;
niz = 0.979;
b = 1.19;
vi = 8.15; %in Villaverde-Ramirez 2006 8.92, in KR 3.48
n = 2.015;

 % Loop over size of b 
%bs = 0.5:1:1.5;
%for i=1:length(bs);
%b = bs(i);
%end

%n=2, psi=2, alpha=.333, vi=8, b=1.2, beta=.99, niz=.979 => ok volatility under MC, but low cyclicality; bad under PC
% n=2.05:2.1 higher correlation but higher volatility also, better with b=1.199 
 
model;

k=(1-delta)*k(-1)+exp(A)*k(-1)^alpha*L^(1-alpha)-n*c;

%I=k-k(-1)*(1-delta);

% L=(((1-alpha)*exp(A)*k(-1)^alpha)/((c-b)*vi))^(phi/(1+alpha*phi)); %perf comp
 L=(((1-alpha)*exp(A)*(k(-1)^alpha))*((teta-1)*c-b*teta)/((c-b)^2*vi))^(phi/(1+alpha*phi)); %mon comp

%(c-b)^(-1)=beta*(1+alpha*exp(A(+1))*k^(alpha-1)*L(+1)^(1-alpha)-delta)*((c(+1)-b)^(-1)); %perf comp
 ((teta-1)*c-b*teta)*(c-b)^(-2)=beta*(1+alpha*exp(A(+1))*k^(alpha-1)*L(+1)^(1-alpha)-delta)*(((teta-1)*c(+1)-b*teta)*(c(+1)-b)^(-2)); %mon comp 


A=niz*A(-1)+zz;

Y=exp(A)*L^(1-alpha)*k^alpha;
%Y=exp(A)*L; %provides better moments
end;

initval;

c  =   	2.1914529;
L  =   	0.0608807939;
k =	91.041666655;
A = 0;
Y = 0.0608;
%I = 25;


end;

steady(maxit=50, solve_algo =0) ;

%check;

shocks;
var zz = 0.0072^2;
end;

%stoch_simul(hp_filter=1600,irf=0, drop=200, periods=2100) c L Y k ;

estimated_params ;
b, uniform_pdf, , ,0,1.2;
end;

varobs c;

estimated_params_init(use_calibration);
end;

%estimation(datafile=rawdata_US_1977Q1_2016q3,mode_compute=7,mode_check,mh_replic=5000,mh_nblocks=2,mh_jscale=0.45,mh_init_scale=0.5,bayesian_irf,moments_varendo) c ;
%estimation(datafile=rawdata2_US_1977Q1_2016q3,mode_check,mh_replic=5000) c ; %  mode_file=Stone_Geary_moments_mode
estimation(datafile=rawdata3_US_1977Q1_2016q3, first_obs=1,nobs=100,mode_compute=5,mode_check,mh_replic=10000,mh_nblocks=2,mh_jscale=0.65,mh_init_scale=0.5,bayesian_irf,moments_varendo) c ;

estimated_params_init(use_calibration);
end;

%datatomfile('dataEtro',[]);  this gives the irf in column 

%stoch_simul(drop=200, order=1, irf=50, periods=2100) c k L Y  ;
%stoch_simul(hp_filter=1600,irf=0, drop=200, periods=2100) c L Y k ;